version: "3.8"

services:
  social-network-db:
    image: mysql:5.7
    container_name: db
    restart: always
    environment:
      MYSQL_DATABASE: social-network
      MYSQL_PASSWORD: password
      MYSQL_ROOT_PASSWORD: root
      MYSQL_USER: user
    ports:
      - "3306:3306"
    networks:
      - local-network
    command: ['mysqld',
              '--character-set-server=utf8mb4',
              '--collation-server=utf8mb4_unicode_ci',
              '--innodb-buffer-pool-size=1000M']

  social-network-server:
    image: stfaustoff/social-network-server:latest # docker.io/stfaustoff/social-network-server
    container_name: server
    ports:
      - "127.0.0.1:8088:8088"
    links:
      - social-network-db
    depends_on:
      - social-network-db
    environment:
      - DB_HOST=jdbc:mysql://db:3306/social-network
      - SERVER_PORT=8088
      - APP_CORS_ALLOWED=http://localhost/
    networks:
      - local-network

  social-network-front:
    image: stfaustoff/social-network-front:latest # docker.io/stfaustoff/social-network-front
    container_name: front
    ports:
      - "80:80"
    links:
      - social-network-server
    depends_on:
      - social-network-server
    environment:
      - API_URL=http://server:8088/api/v1
    networks:
      - local-network

  social-network-cache:
    image: redis:6.2-alpine
    container_name: cache
    restart: always
    ports:
      - "6379:6379"
    command: redis-server --save 20 1 --loglevel warning
    networks:
      - local-network

  social-network-queue:
    image: rabbitmq:3-management-alpine
    container_name: queue
    ports:
      - "5672:5672"
      - "15672:15672"
    networks:
      - local-network

networks:
  local-network:
    driver: bridge
    name: local-network